package com.zipcodewilmington.singlylinkedlist;


/**
 * Created by leon on 1/10/18.
 */
public class SinglyLinkedList {

    private Node head;
    private Node tail;
    private int size;

    public SinglyLinkedList(Node head, Node tail, int size) {
        this.head = head;
        this.tail = tail;
        this.size = size;
    }


    public void addNode(int val, int spot){
        Node someNode = new Node();
        Node startednode = head;
        spot = spot-1;
        for (int i = 1; i < size; i++){
            if (i == spot){
                Node temp = startednode.getLink();
                startednode.setLink(someNode);
                someNode.setLink(temp);
                break;
            }
            startednode = startednode.getLink();
        }
        size++;
    }

    public void removeNode(int spot) {
        if(spot == 1){
            head = head.getLink();
            size--;
            return;
        }
        if(spot == size){
            Node a = head;
            Node b = head;
            while (a != tail){
                b = a;
                a = a.getLink();
            }
            tail = b;
            tail.setLink(null);
            size--;
            return;
        }
        Node nodeToRemove = head;
        spot = spot-1;
        for (int i = 1; i < size - 1; i++){
            if (i == spot){
                Node temp = nodeToRemove.getLink();
                temp = temp.getLink();
                nodeToRemove.setLink(temp);
                break;
            }
            nodeToRemove = nodeToRemove.getLink();
        }
        size--;
    }

    public boolean contains(int val){
        if (find(val) != -1){
            return true;
        }
        return false;
    }

    public int find(int val){
        Node someNode = head;
        int spot = 0;
        while (true){
            if (someNode == null){
                break;
            }
            else if(someNode.data == val){
                return spot;
            }
            someNode = someNode.getLink();
            spot++;
        }
        return -1;
    }

    public int size(){
        return this.size;

    }

    public int get(int val) {
        if (val == 0) {
            return head.data;
        } else {
            int count = 1;
            Node thing = head;
            while (count != val) {
                thing = thing.link;
                count++;
            }
            return thing.link.data;

        }
    }

    public SinglyLinkedList copy(){
        SinglyLinkedList copy = new SinglyLinkedList(head, tail, size);
        for (int i = 1; i < this.size(); i ++){
            copy.addNode(this.get(i), size);
        }
        return copy;
    }

    public void sort(){
        Node firstNode = head;
        Node nextNode = firstNode.getLink();
        int temp;
        for (int i = 0; i < size()-1; i++){
            for (int j = i+1; j< size() && nextNode != null; j++){
                if (firstNode.getData() > (nextNode.getData())){
                    temp = nextNode.getData();
                    nextNode.setData(firstNode.getData());
                    firstNode.setData(temp);
                }
            }
        }
    }

}
